unit PLUGINLib_TLB;

// ************************************************************************ //
// WARNING                                                                  //
// -------                                                                  //
// The types declared in this file were generated from data read from a     //
// Type Library. If this type library is explicitly or indirectly (via      //
// another type library referring to this type library) re-imported, or the //
// 'Refresh' command of the Type Library Editor activated while editing the //
// Type Library, the contents of this file will be regenerated and all      //
// manual modifications will be lost.                                       //
// ************************************************************************ //

// PASTLWTR : $Revision:   1.11.1.75  $
// File generated on 26.11.2004 13:28:14 from Type Library described below.

// ************************************************************************ //
// Type Lib: E:\Projects\For Programmers\UniPro\B123\Plugin\MSVC++6.0\ReleaseMinDependency\Plugin.dll
// IID\LCID: {66F9FA05-1413-4967-8235-B6E8D72348C0}\0
// Helpfile: 
// HelpString: Boxdo Plugin 1.0 Type Library
// Version:    1.0
// ************************************************************************ //

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL;

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:      //
//   Type Libraries     : LIBID_xxxx                                    //
//   CoClasses          : CLASS_xxxx                                    //
//   DISPInterfaces     : DIID_xxxx                                     //
//   Non-DISP interfaces: IID_xxxx                                      //
// *********************************************************************//
const
  LIBID_PLUGINLib: TGUID = '{66F9FA05-1413-4967-8235-B6E8D72348C0}';
  IID_IBoxDOPlugin: TGUID = '{4587DE9F-F932-4225-9D0D-C244CD4DEFD3}';
  CLASS_BoxDOTestPlugin: TGUID = '{BA084AC9-6715-4F52-BCA3-59C222DD7EBC}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                  //
// *********************************************************************//
// __MIDL___MIDL_itf_Plugin_0000_0002 constants
type
  __MIDL___MIDL_itf_Plugin_0000_0002 = TOleEnum;
const
  paMemory = $00000000;
  paCursors = $00000001;
  paPeriod = $00000002;

// __MIDL___MIDL_itf_Plugin_0000_0001 constants
type
  __MIDL___MIDL_itf_Plugin_0000_0001 = TOleEnum;
const
  pvMinimum = $00000000;
  pvMaximum = $00000001;
  pvPeakToPeak = $00000002;
  pvAverage = $00000003;
  pvACRootMeanSquare = $00000004;
  pvDCRootMeanSquare = $00000005;
  pvBase = $00000006;
  pvTop = $00000007;
  pvAmplitude = $00000008;
  pvFallPreShoot = $00000009;
  pvRisePreShoot = $0000000A;
  pvFallOverShoot = $0000000B;
  pvRiseOverShoot = $0000000C;
  ptPeriod = $0000000D;
  ptFrequency = $0000000E;
  ptRiseTime = $0000000F;
  ptFallTime = $00000010;
  ptPositiveWidth = $00000011;
  ptNegativeWidth = $00000012;
  ptDutyCycle = $00000013;
  ptMimimumTime = $00000014;
  ptMaximumTime = $00000015;
  pmNotCalculated = $00000016;

type

// *********************************************************************//
// Forward declaration of interfaces defined in Type Library            //
// *********************************************************************//
  IBoxDOPlugin = interface;
  IBoxDOPluginDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                     //
// (NOTE: Here we map each CoClass to its Default Interface)            //
// *********************************************************************//
  BoxDOTestPlugin = IBoxDOPlugin;


// *********************************************************************//
// Declaration of structures, unions and aliases.                       //
// *********************************************************************//
  PInteger1 = ^Integer; {*}
  PDouble1 = ^Double; {*}
  PWord1 = ^Word; {*}
  PUserType1 = ^ParameterType; {*}

  ParameterArea = __MIDL___MIDL_itf_Plugin_0000_0002; 
  ParameterType = __MIDL___MIDL_itf_Plugin_0000_0001; 

// *********************************************************************//
// Interface: IBoxDOPlugin
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {4587DE9F-F932-4225-9D0D-C244CD4DEFD3}
// *********************************************************************//
  IBoxDOPlugin = interface(IDispatch)
    ['{4587DE9F-F932-4225-9D0D-C244CD4DEFD3}']
    function Get_Title: WideString; safecall;
    procedure AttachDevice(const DeviceID: WideString); safecall;
    procedure DetachDevice(const DeviceID: WideString); safecall;
    procedure OnStart(const DeviceID: WideString); safecall;
    procedure OnStop(const DeviceID: WideString); safecall;
    procedure OnDataReady(const DeviceID: WideString; fSamplingTime: Double; 
                          bInterleaving: Integer; var bChannelEnabled: Integer; 
                          var fZeroLevel: Double; var fVoltsPerCode: Double; nSize0: SYSINT; 
                          var pData0: Word; nSize1: SYSINT; var pData1: Word); safecall;
    procedure OnParamsReady(const DeviceID: WideString; nArea: ParameterArea; 
                            var fCursorTimes: Double; nCount: SYSINT; var pTypes: ParameterType; 
                            var pValues0: Double; var pValues1: Double); safecall;
    property Title: WideString read Get_Title;
  end;

// *********************************************************************//
// DispIntf:  IBoxDOPluginDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {4587DE9F-F932-4225-9D0D-C244CD4DEFD3}
// *********************************************************************//
  IBoxDOPluginDisp = dispinterface
    ['{4587DE9F-F932-4225-9D0D-C244CD4DEFD3}']
    property Title: WideString readonly dispid 1;
    procedure AttachDevice(const DeviceID: WideString); dispid 2;
    procedure DetachDevice(const DeviceID: WideString); dispid 3;
    procedure OnStart(const DeviceID: WideString); dispid 4;
    procedure OnStop(const DeviceID: WideString); dispid 5;
    procedure OnDataReady(const DeviceID: WideString; fSamplingTime: Double; 
                          bInterleaving: Integer; var bChannelEnabled: Integer; 
                          var fZeroLevel: Double; var fVoltsPerCode: Double; nSize0: SYSINT; 
                          var pData0: {??Word} OleVariant; nSize1: SYSINT; 
                          var pData1: {??Word} OleVariant); dispid 6;
    procedure OnParamsReady(const DeviceID: WideString; nArea: ParameterArea; 
                            var fCursorTimes: Double; nCount: SYSINT; var pTypes: ParameterType; 
                            var pValues0: Double; var pValues1: Double); dispid 7;
  end;

  CoBoxDOTestPlugin = class
    class function Create: IBoxDOPlugin;
    class function CreateRemote(const MachineName: string): IBoxDOPlugin;
  end;

implementation

uses ComObj;

class function CoBoxDOTestPlugin.Create: IBoxDOPlugin;
begin
  Result := CreateComObject(CLASS_BoxDOTestPlugin) as IBoxDOPlugin;
end;

class function CoBoxDOTestPlugin.CreateRemote(const MachineName: string): IBoxDOPlugin;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_BoxDOTestPlugin) as IBoxDOPlugin;
end;

end.
