#if !defined(AFX_MAINDLG_H__499B4732_EBA7_4C58_BBC9_F2B0F9088B8E__INCLUDED_)
#define AFX_MAINDLG_H__499B4732_EBA7_4C58_BBC9_F2B0F9088B8E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MainDlg.h : header file
//
#include "OscView.h"
#include "vector"
#include "afxcmn.h"

using namespace std;
#define WM_NEWDATA (WM_USER + 13)

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog
// ,    
class CMainDlg : public CDialog
{
// Construction
public:
	CMainDlg(CWnd* pParent = NULL);   // standard constructor
	COscView m_Osc0;
	COscView m_Osc1;

	bool m_bQuit;
// Dialog Data
	//{{AFX_DATA(CMainDlg)
	enum { IDD = IDD_DIALOG_MAIN };
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
private:
	void PrepareViews();
	void UpdateParamsView();
protected:
	int m_iX;
	int m_iY;
	HICON m_hIcon;
	
	// Generated message map functions
	//{{AFX_MSG(CMainDlg)
	afx_msg void OnPaint();
	virtual BOOL OnInitDialog();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	LRESULT OnNewData(WPARAM wParam, LPARAM lParam);
	
public:
protected:
	virtual void OnCancel();
	virtual void OnOK();
public:
protected:
	BOOL m_bUpdate;
};

struct CThreadData
{
	CMainDlg *pDlg;
	HANDLE  m_hThread;
	BSTR DeviceID; 
	double fSamplingTime;
	BOOL bInterleaving;		
	BOOL bChannelEnabled0;
	BOOL bChannelEnabled1;
	double fZeroLevel0;
	double fZeroLevel1;
	double fVoltsPerCode0;
	double fVoltsPerCode1;
	int nSize0;
	int nSize1;
	USHORT *pData0;
	USHORT *pData1;
	BOOL bUpdate;
	CThreadData(){
		pData0 = NULL;
		pData1 = NULL;
		nSize0 = 0;
		nSize1 = 0;
		bUpdate = true;
	}
	~CThreadData(){
		if (pData0)
			delete [] pData0;
		if (pData1)
			delete [] pData1;
	}
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINDLG_H__499B4732_EBA7_4C58_BBC9_F2B0F9088B8E__INCLUDED_)
